<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RekamMedis;
use App\Models\Pasien;
use App\Models\Dokter;
use App\Models\Obat;

class LaporanController extends Controller
{
    public function show($id)
    {
        if(!\Helper::hakAkses('Laporan','View')){            
            return redirect()->back()->with('error', 'Anda Tidak Memiliki Hak Akses Untuk Membuka Halaman Ini');
        }

        $menu = "Laporan";
        $title = ucwords(str_replace('_', ' ', $id));
        $url = "laporan/";
        $view = "laporan." . $id;
        $datas = array();
        $url .= $id;

        $from = ($_GET['from']) ?? date("Y-m-01");
        $to = ($_GET['to']) ?? date("Y-m-t");
        $getPasien = ($_GET['pasien']) ?? null;
        $getDokter = ($_GET['dokter']) ?? null;
        $getTahun = ($_GET['tahun']) ?? date('Y');
        
        switch ($id) {
            case 'pasien':
                $datas = Pasien::all();
                $datas = $datas->sortByDesc(function($data){
                    return $data->total_kunjungan;
                });
                break;

            case 'terapis':
                $datas = Dokter::get();
                $datas = $datas->sortByDesc(function($data){
                    return $data->total_pelayanan;
                });
                break;
            
            case 'layanan':
                $datas = Obat::all();
                $datas = $datas->sortByDesc(function($data){
                    return $data->terlaris;
                });
                break;
            
            case 'rekam_medis':
                $datas = RekamMedis::orderBy('created_at', 'DESC')->whereHas('dokterRm', function($dokterRm)use($getDokter){
                    if ($getDokter) {
                        $dokterRm->where('dokter_id', $getDokter);
                    }
                });
                if ($getPasien) {
                    $datas = $datas->where('pasien_id', $getPasien);
                }
                $datas = $datas->whereBetween('tgl_periksa', [$from,$to])->get();
                break;

            default:
                # code...
                break;
        }
        $pasiens = Pasien::all();
        $dokters = Dokter::all();

        return view($view, compact('menu', 'title', 'url', 'datas', 'pasiens', 'dokters'));

    }
}
